# generated by datamodel-codegen:
#   filename:  input.json
#   timestamp: 2024-10-25T08:14:24+00:00

from __future__ import annotations

from typing import Optional

from pydantic import BaseModel, Field


class Inputs(BaseModel):
    context: str = Field(..., description="The context to be used for answering the question")
    question: str = Field(..., description="The question to be answered")


class QuestionAnsweringParameters(BaseModel):
    top_k: Optional[int] = Field(
        None,
        description="The number of answers to return (will be chosen by order of likelihood). Note that we return less than topk answers if there are not enough options available within the context.",
    )
    doc_stride: Optional[int] = Field(
        None,
        description="If the context is too long to fit with the question for the model, it will be split in several chunks with some overlap. This argument controls the size of that overlap.",
    )
    max_answer_len: Optional[int] = Field(
        None,
        description="The maximum length of predicted answers (e.g., only answers with a shorter length are considered).",
    )
    max_seq_len: Optional[int] = Field(
        None,
        description="The maximum length of the total sentence (context + question) in tokens of each chunk passed to the model. The context will be split in several chunks (using docStride as overlap) if needed.",
    )
    max_question_len: Optional[int] = Field(
        None,
        description="The maximum length of the question after tokenization. It will be truncated if needed.",
    )
    handle_impossible_answer: Optional[bool] = Field(None, description="Whether to accept impossible as an answer.")
    align_to_words: Optional[bool] = Field(
        None,
        description="Attempts to align the answer to real words. Improves quality on space separated languages. Might hurt on non-space-separated languages (like Japanese or Chinese)",
    )


class QuestionAnsweringInput(BaseModel):
    inputs: Inputs = Field(
        ...,
        description="One (context, question) pair to answer",
        title="QuestionAnsweringInputData",
    )
    parameters: Optional[QuestionAnsweringParameters] = Field(None, description="Additional inference parameters")
