# generated by datamodel-codegen:
#   filename:  input.json
#   timestamp: 2024-10-25T08:14:31+00:00

from __future__ import annotations

from enum import Enum
from typing import Any, Dict, Optional

from pydantic import BaseModel, Field


class Truncation(Enum):
    do_not_truncate = "do_not_truncate"
    longest_first = "longest_first"
    only_first = "only_first"
    only_second = "only_second"


class TranslationParameters(BaseModel):
    src_lang: Optional[str] = Field(
        None,
        description="The source language of the text. Required for models that can translate from multiple languages.",
    )
    tgt_lang: Optional[str] = Field(
        None,
        description="Target language to translate to. Required for models that can translate to multiple languages.",
    )
    clean_up_tokenization_spaces: Optional[bool] = Field(
        None,
        description="Whether to clean up the potential extra spaces in the text output.",
    )
    truncation: Optional[Truncation] = Field(
        None,
        description="The truncation strategy to use.",
        title="TranslationTruncationStrategy",
    )
    generate_parameters: Optional[Dict[str, Any]] = Field(
        None,
        description="Additional parametrization of the text generation algorithm.",
        title="generateParameters",
    )


class TranslationInput(BaseModel):
    inputs: str = Field(..., description="The text to translate.")
    parameters: Optional[TranslationParameters] = Field(None, description="Additional inference parameters")
